import mysql.connector
import os.path
import pytz
from datetime import datetime
from src.gmaps import Gmaps

def upload_to_folder():
    path = 'output'
    print ('Started:-------------------------------------------------')
    local_conn = mysql.connector.connect(
        user='localUser', 
        password='Local@Password2024', 
        host='localhost', 
        database='localDB'
    )
    local_cur = local_conn.cursor()
    local_cur.execute("SELECT * from `remote-subcats` where `status` = 'new' ORDER BY RAND() LIMIT 4")
    response = local_cur.fetchall()

    id_list = []

    for row in response:
        id = row[0]
        id_list.append(id)

    
    # print (f"ID: {response[0]}, Query: {response[1]}, Status: {response[2]}")

    IST = pytz.timezone('Asia/Kolkata')
    loop_start_now = datetime.now(IST)
    query_start_time = loop_start_now.strftime("%Y-%m-%d %I:%M:%S")

    record_sql = f"UPDATE `remote-subcats` SET `status` = 'working', `timestamp` = '{query_start_time}' WHERE `id` IN ('{id_list[0]}','{id_list[1]}', '{id_list[2]}', '{id_list[3]}')"
    local_cur.execute(record_sql)
    local_conn.commit()
    local_cur.close()
    local_conn.close()

    i = 1
    for row in response:
        id = row[0]
        query = row[1]
        status = row[2]

        queries = [f"{query}"]
        IST = pytz.timezone('Asia/Kolkata') 
        scrape_start_now = datetime.now(IST)
        scrape_start_time = scrape_start_now.strftime("%Y/%m/%d %I:%M:%S")
        print(f"""{i}: Started at {scrape_start_time} : {str(queries).replace("['", '').replace("']", '')}""")
        
        fields = [
            Gmaps.Fields.PLACE_ID,
            Gmaps.Fields.NAME,
            Gmaps.Fields.DESCRIPTION,
            Gmaps.Fields.RATING,
            Gmaps.Fields.REVIEWS,
            Gmaps.Fields.WEBSITE,
            Gmaps.Fields.PHONE,
            Gmaps.Fields.DETAILED_ADDRESS,
            Gmaps.Fields.MAIN_CATEGORY,
            Gmaps.Fields.CATEGORIES,
            Gmaps.Fields.LINK,
        ]

        Gmaps.places(queries, fields=fields)
        IST = pytz.timezone('Asia/Kolkata') 
        scraped_now = datetime.now(IST)
        scraped_time = scraped_now.strftime("%Y/%m/%d %I:%M:%S")
        elapsed_time = scraped_now - scrape_start_now
        print(f"""Scraped in {elapsed_time}, at {scraped_time} : {str(queries).replace("['", '').replace("']", '')}""")
        print ('----')
        i +=1

    local_conn = mysql.connector.connect(
        user='localUser', 
        password='Local@Password2024', 
        host='localhost', 
        database='localDB'
    )
    local_cur = local_conn.cursor()
    IST = pytz.timezone('Asia/Kolkata') 
    now = datetime.now(IST)
    finished_time = now.strftime("%Y-%m-%d %I:%M:%S")
    update_record_sql = f"UPDATE `remote-subcats` SET `status` = 'done', `timestamp` = '{finished_time}' WHERE `id` IN ('{id_list[0]}','{id_list[1]}', '{id_list[2]}', '{id_list[3]}')"    
    local_cur.execute(update_record_sql)
    local_conn.commit()
    local_cur.close()
    local_conn.close()

    loop_finished_now = datetime.now(IST)
    loop_elapsed = loop_finished_now - loop_start_now
    print (f"Loop Time: {loop_elapsed}")
    print ('---------------------------------')

if __name__ == "__main__":
    upload_to_folder()
