import mysql.connector
import os.path
import pytz
from datetime import datetime
from src.gmaps import Gmaps

def upload_to_folder():
    path = 'output'
    
    local_conn = mysql.connector.connect(
        user='localUser', 
        password='Local@Password2024', 
        host='localhost', 
        database='localDB'
    )

    local_cur = local_conn.cursor()
    local_cur.execute("SELECT * from `remote-subcats` where `status` = 'new' ORDER BY RAND() LIMIT 1")
    response = local_cur.fetchone()
    
    # print (f"ID: {response[0]}, Query: {response[1]}, Status: {response[2]}")

    IST = pytz.timezone('Asia/Kolkata')
    loop_start_now = datetime.now(IST)
    query_start_time = loop_start_now.strftime("%Y-%m-%d %I:%M:%S")

    record_sql = f"UPDATE `remote-subcats` SET `status` = 'working', `timestamp` = '{query_start_time}' WHERE `id` = '{response[0]}'"
    local_cur.execute(record_sql)
    local_conn.commit()
    local_cur.close()
    local_conn.close()

    query_start_now = datetime.now(IST)
    query_start_time = query_start_now.strftime("%Y-%m-%d %I:%M:%S")

    id = response[0]
    query = response[1]
    status = response[2]

    queries = [f"{query}"]
    IST = pytz.timezone('Asia/Kolkata') 
    scrape_start_now = datetime.now(IST)
    scrape_start_time = scrape_start_now.strftime("%Y/%m/%d %I:%M:%S")
    print(f"Started at {scrape_start_time} : {query}")
        
    fields = [
        Gmaps.Fields.PLACE_ID,
        Gmaps.Fields.NAME,
        Gmaps.Fields.DESCRIPTION,
        Gmaps.Fields.RATING,
        Gmaps.Fields.REVIEWS,
        Gmaps.Fields.WEBSITE,
        Gmaps.Fields.PHONE,
        Gmaps.Fields.DETAILED_ADDRESS,
        Gmaps.Fields.MAIN_CATEGORY,
        Gmaps.Fields.CATEGORIES,
        Gmaps.Fields.LINK,
    ]

    Gmaps.places(queries, fields=fields)
    
    IST = pytz.timezone('Asia/Kolkata') 
    scraped_now = datetime.now(IST)
    scraped_time = scraped_now.strftime("%Y/%m/%d %I:%M:%S")
    elapsed_time = scraped_now - scrape_start_now
    print(f"Scraped in {elapsed_time}, at {scraped_time} : {query}")

    local_conn = mysql.connector.connect(
        user='localUser', 
        password='Local@Password2024', 
        host='localhost', 
        database='localDB'
    )
    local_cur = local_conn.cursor()
    IST = pytz.timezone('Asia/Kolkata') 
    loop_end_now = datetime.now(IST)
    query_end_time = loop_end_now.strftime("%Y-%m-%d %I:%M:%S")
    update_record_sql = f"UPDATE `remote-subcats` SET `status` = 'done', `timestamp` = '{query_end_time}' WHERE `id` = '{response[0]}'"    
    local_cur.execute(update_record_sql)
    local_conn.commit()
    local_cur.close()
    local_conn.close()

if __name__ == "__main__":
    upload_to_folder()
